## owl 0~git20200813

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(owl)

if (CMAKE_C_COMPILER_ID MATCHES "GNU" OR CMAKE_C_COMPILER_ID MATCHES "Clang")
    add_compile_options("-Wall" "-Wextra")
endif ()

add_library(radiotap radiotap/radiotap.c)
target_compile_definitions(radiotap PRIVATE -D_BSD_SOURCE -DRADIOTAP_SUPPORT_OVERRIDES)

add_subdirectory(src)

add_subdirectory(daemon)

option(INSTALL_GTEST "" OFF)
add_subdirectory(googletest)

add_subdirectory(tests)

=== daemon/CMakeLists.txt ===
set(CMAKE_CXX_STANDARD 11)

include(FindPackageHandleStandardArgs)

set(SOURCES PRIVATE
        io.c
        io.h
        core.c
        core.h
        netutils.c
        netutils.h)

if (APPLE)
    list(APPEND SOURCES corewlan.m corewlan.h)
endif ()

add_executable(owl "")

target_sources(owl ${SOURCES} owl.c)

find_library(libpcap_LIBRARY NAMES pcap)
find_path(libpcap_INCLUDE pcap.h)
find_package_handle_standard_args(libpcap DEFAULT_MSG libpcap_LIBRARY libpcap_INCLUDE)
if (NOT libpcap_FOUND)
    message(FATAL_ERROR "libpcap not found")
endif ()

find_library(libev_LIBRARY NAMES ev)
find_path(libev_INCLUDE ev.h PATHS /usr/local/include)
find_package_handle_standard_args(libev DEFAULT_MSG libev_LIBRARY libev_INCLUDE)
if (NOT libev_FOUND)
    message(FATAL_ERROR "libev not found")
endif ()

if (APPLE)
    find_library(FOUNDATION Foundation)
    find_library(COREWLAN CoreWLAN)
    find_library(SYSTEMCONFIGURATION SystemConfiguration)
endif ()

target_include_directories(owl PRIVATE ${CMAKE_SOURCE_DIR}/src ${libev_INCLUDE})

target_link_libraries(owl awdl ${libpcap_LIBRARY} ${libev_LIBRARY})
if (APPLE)
    target_link_libraries(owl ${FOUNDATION} ${COREWLAN} ${SYSTEMCONFIGURATION})
else ()
    target_include_directories(owl PRIVATE /usr/include/libnl3)
    target_link_libraries(owl nl-3 nl-genl-3 nl-route-3)
endif ()

install(TARGETS owl DESTINATION bin)

=== debian/changelog ===
owl (0~git20200813-0parrot1) lory; urgency=medium

  * Rebuild for Parrot 6.0.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Thu, 07 Sep 2023 02:13:20 +0200

owl (0~git20200813-0kali2) kali-dev; urgency=medium

  [ Kali Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit,
    Repository, Repository-Browse.
  [ Ben Wilson ]
  * Consistency with tabs to spaces
  * Remove template comment and switch spaces to tabs
  [ Steev Klimaszewski ]
  * Add d/watch file
  * Prepare for Release

 -- Steev Klimaszewski <steev@kali.org>  Wed, 14 Dec 2022 13:21:22 -0600

owl (0~git20200813-0kali1) kali-dev; urgency=medium

  * Initial release

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 19 Oct 2020 17:14:11 +0200

=== debian/control ===
Source: owl
Section: utils
Priority: optional
Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libev-dev,
               libgtest-dev,
               libnl-3-dev,
               libnl-genl-3-dev,
               libnl-route-3-dev,
               libpcap-dev,
               radiotap-library
Standards-Version: 4.5.0
Homepage: https://owlink.org/
Rules-Requires-Root: no

Package: owl
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, radiotap-library
Description: open Apple Wireless Direct Link (AWDL)
 This package contains an open implementation of the Apple Wireless Direct Link
 (AWDL) ad hoc protocol for Linux and macOS written in C and part of the Open
 Wireless Link project.
 .
 OWL runs in user space and makes use of Linux’s Netlink API for Wi-Fi specific
 operations such as channel switching and to integrate itself in the Linux
 networking stack by providing a virtual network interface such that existing
 IPv6-capable programs can use AWDL without modification.

=== debian/rules ===
#!/usr/bin/make -f

# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

## owl 0~git20220130

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 endif ()
 
 add_library(radiotap radiotap/radiotap.c)
-target_compile_definitions(radiotap PRIVATE -D_BSD_SOURCE -DRADIOTAP_SUPPORT_OVERRIDES)
+target_compile_definitions(radiotap PRIVATE -D_BSD_SOURCE -D_DEFAULT_SOURCE -DRADIOTAP_SUPPORT_OVERRIDES)
 
 add_subdirectory(src)

=== daemon/CMakeLists.txt ===
set(CMAKE_CXX_STANDARD 11)

set(SOURCES PRIVATE
        io.c
        io.h
        core.c
        core.h
        netutils.c
        netutils.h)

if (APPLE)
    list(APPEND SOURCES corewlan.m corewlan.h)
endif ()

add_executable(owl "")

target_sources(owl ${SOURCES} owl.c)

find_path(pcap_INCLUDE pcap.h REQUIRED)
find_library(pcap_LIBRARY pcap REQUIRED)

find_path(ev_INCLUDE ev.h PATHS /usr/local/include REQUIRED)
find_library(ev_LIBRARY ev REQUIRED)

if (APPLE)
    find_library(FOUNDATION Foundation REQUIRED)
    find_library(COREWLAN CoreWLAN REQUIRED)
    find_library(SYSTEMCONFIGURATION SystemConfiguration REQUIRED)
else ()
    find_path(nl_INCLUDE netlink/version.h PATH_SUFFIXES libnl3 REQUIRED)
    find_library(nl_LIBRARY nl-3 REQUIRED)
    find_library(nlgenl_LIBRARY nl-genl-3 REQUIRED)
    find_library(nlroute_LIBRARY nl-route-3 REQUIRED)
endif ()

target_include_directories(owl PRIVATE ${CMAKE_SOURCE_DIR}/src ${ev_INCLUDE} ${pcap_INCLUDE})

target_link_libraries(owl awdl ${pcap_LIBRARY} ${ev_LIBRARY})
if (APPLE)
    target_link_libraries(owl ${FOUNDATION} ${COREWLAN} ${SYSTEMCONFIGURATION})
else ()
    target_include_directories(owl PRIVATE ${nl_INCLUDE})
    target_link_libraries(owl ${nl_LIBRARY} ${nlgenl_LIBRARY} ${nlroute_LIBRARY})
endif ()

install(TARGETS owl DESTINATION bin)

=== src/CMakeLists.txt ===
add_library(awdl "")

target_sources(awdl PRIVATE
        log.c
        log.h
        state.c
        state.h
        election.c
        election.h
        sync.c
        sync.h
        channel.c
        channel.h
        schedule.c
        schedule.h
        tx.c
        tx.h
        rx.c
        rx.h
        frame.c
        frame.h
        crc32.c
        crc32.h
        wire.c
        wire.h
        peers.c
        peers.h
        version.c
        version.h
        hashmap.c
        hashmap.h
        siphash24.c
        siphash24.h
        circular_buffer.c
        circular_buffer.h
)

target_include_directories(awdl PRIVATE ${CMAKE_SOURCE_DIR}/radiotap)

target_link_libraries(awdl radiotap)

=== tests/CMakeLists.txt ===
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

include_directories(${gtest_SOURCE_DIR}/include ${gtest_SOURCE_DIR})

add_executable(tests "")

target_sources(tests PRIVATE
        test_wire.cpp
        test_awdl_sync.cpp
        test_awdl_peers.cpp
        test_awdl_election.cpp
)

target_include_directories(tests PRIVATE ${CMAKE_SOURCE_DIR}/src)

target_link_libraries(tests gtest gtest_main)
target_link_libraries(tests awdl)

=== debian/changelog ===
owl (0~git20220130-0kali1) kali-dev; urgency=medium

  * New upstream version 0~git20220130
  * Refresh patches
  * Update standards version to 4.6.2, no changes needed.
  * Prepare for Release

 -- Steev Klimaszewski <steev@kali.org>  Thu, 12 Oct 2023 10:35:21 -0500

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: owl
 Section: utils
 Priority: optional
-Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
-Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
+Maintainer: Kali Developers <devel@kali.org>
+Uploaders: Sophie Brun <sophie@offensive-security.com>
 Build-Depends: cmake,
                debhelper-compat (= 13),
                libev-dev,
@@ -12,8 +12,10 @@
                libnl-route-3-dev,
                libpcap-dev,
                radiotap-library
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Homepage: https://owlink.org/
+Vcs-Browser: https://gitlab.com/kalilinux/packages/owl
+Vcs-Git: https://gitlab.com/kalilinux/packages/owl.git
 Rules-Requires-Root: no
 
 Package: owl

=== debian/watch ===
version=4
opts=mode=git,pretty=0~git%cd \
  https://github.com/seemoo-lab/owl HEAD
# Upstream does not yet tag releases, use this once they do
#opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/owl-$1\.tar\.gz/ \
#  https://github.com/seemoo-lab/owl/tags .*/v?(\d\S*)\.tar\.gz

## owl 0.1.1

=== DESCRIPTION ===
Package: owl
Title: Generalized Linear Models Regularized with the Sorted L1-Norm
Version: 0.1.1
Authors@R: 
    c(person("Johan", "Larsson", role = c("aut", "cre"),
             email = "johan.larsson@stat.lu.se",
             comment = c(ORCID = "0000-0002-4029-5945")),
      person("Jonas",  "Wallin", role = "aut",
             email = "jonas.wallin@stat.lu.se",
             comment = c(ORCID = "0000-0003-0381-6593")),
      person("Malgorzata", "Bogdan", role = "ctb",
             comment = "code adapted from 'SLOPE'"),
      person("Ewout", "van den Berg", role = "ctb",
             comment = "code adapted from 'SLOPE'"),
      person("Chiara", "Sabatti", role = "ctb",
             comment = "code adapted from 'SLOPE'"),
      person("Emmanuel", "Candes", role = "ctb",
             comment = "code adapted from 'SLOPE'"),
      person("Evan", "Patterson", role = "ctb",
             comment = "code adapted from 'SLOPE'"),
      person("Weijie", "Su", role = "ctb",
             comment = "code adapted from 'SLOPE'"),
      person("Jerome", "Friedman", role = "ctb",
             comment = "code adapted from 'glmnet'"),
      person("Trevor", "Hastie", role = "ctb",
             comment = "code adapted from 'glmnet'"),
      person("Rob", "Tibshirani", role = "ctb",
             comment = "code adapted from 'glmnet'"),
      person("Balasubramanian", "Narasimhan", role = "ctb",
             comment = "code adapted from 'glmnet'"),
      person("Noah", "Simon", role = "ctb",
             comment = "code adapted from 'glmnet'"),
      person("Junyang", "Qian", role = "ctb",
             comment = "code adapted from 'glmnet'"))
Description: Efficient implementations for Sorted L-One Penalized Estimation
    (SLOPE): generalized linear models regularized with the 
    sorted L1-norm (Bogdan et al. (2015) <doi:10/gfgwzt>)
    or, equivalently, ordered weighted L1-norm (OWL). Supported models include
    ordinary least-squares regression, binomial regression, multinomial
    regression, and Poisson regression. Both dense and sparse 
    predictor matrices are supported. In addition, the package features
    predictor screening rules that enable fast and efficient solutions to 
    high-dimensional problems.
License: GPL-3
LazyData: true
Depends: R (>= 3.3.0)
Imports: lattice, Matrix, methods, Rcpp
LinkingTo: Rcpp, RcppArmadillo (>= 0.9.200.7.0)
Suggests: caret, covr, glmnet, knitr, rmarkdown, SLOPE, spelling,
        testthat (>= 2.1.0)
RoxygenNote: 7.0.2
Language: en-US
Encoding: UTF-8
URL: https://github.com/jolars/owl, https://jolars.github.io/owl
BugReports: https://github.com/jolars/owl/issues
VignetteBuilder: knitr
NeedsCompilation: yes
Packaged: 2020-01-30 09:17:41 UTC; johan
Author: Johan Larsson [aut, cre] (<https://orcid.org/0000-0002-4029-5945>),
  Jonas Wallin [aut] (<https://orcid.org/0000-0003-0381-6593>),
  Malgorzata Bogdan [ctb] (code adapted from 'SLOPE'),
  Ewout van den Berg [ctb] (code adapted from 'SLOPE'),
  Chiara Sabatti [ctb] (code adapted from 'SLOPE'),
  Emmanuel Candes [ctb] (code adapted from 'SLOPE'),
  Evan Patterson [ctb] (code adapted from 'SLOPE'),
  Weijie Su [ctb] (code adapted from 'SLOPE'),
  Jerome Friedman [ctb] (code adapted from 'glmnet'),
  Trevor Hastie [ctb] (code adapted from 'glmnet'),
  Rob Tibshirani [ctb] (code adapted from 'glmnet'),
  Balasubramanian Narasimhan [ctb] (code adapted from 'glmnet'),
  Noah Simon [ctb] (code adapted from 'glmnet'),
  Junyang Qian [ctb] (code adapted from 'glmnet')
Maintainer: Johan Larsson <johan.larsson@stat.lu.se>
Repository: CRAN
Date/Publication: 2020-02-11 10:50:08 UTC
